//
// WARNING:
// This file was taken from the TIFA library
//     http://www.lix.polytechnique.fr/Labo/Jerome.Milan/tifa/tifa.xhtml
// and is subject to the LGPL version 2.1 or later.
//

#include <stdlib.h>
#include "stopwatch.h"

//----------------------------------------------------------------------------
void init_stopwatch(stopwatch_t* const watch) {    
    watch->elapsed_usec = 0;
    watch->is_running   = false;
}
//----------------------------------------------------------------------------
void start_stopwatch(stopwatch_t* const watch) {    
    if (! watch->is_running) {
        getrusage(RUSAGE_SELF, watch->rsg);
        
        watch->started_usec  = (uint64_t) watch->rsg->ru_utime.tv_sec;
        watch->started_usec += (uint64_t) watch->rsg->ru_stime.tv_sec;
        watch->started_usec *= 1000000;
        watch->started_usec += (uint64_t) watch->rsg->ru_utime.tv_usec;
        watch->started_usec += (uint64_t) watch->rsg->ru_stime.tv_usec;
        
        watch->is_running = true;
    }
}
//----------------------------------------------------------------------------
void stop_stopwatch(stopwatch_t* const watch) {
    if (watch->is_running) {
        getrusage(RUSAGE_SELF, watch->rsg);
        
        watch->elapsed_usec += (   (uint64_t) watch->rsg->ru_utime.tv_sec
                                 + (uint64_t) watch->rsg->ru_stime.tv_sec
                               ) * 1000000;                                         
        watch->elapsed_usec += (uint64_t) watch->rsg->ru_utime.tv_usec;
        watch->elapsed_usec += (uint64_t) watch->rsg->ru_stime.tv_usec;
        watch->elapsed_usec -= watch->started_usec;
        
        watch->is_running  = false;
    }
}
//----------------------------------------------------------------------------
void reset_stopwatch(stopwatch_t* const watch) {
    watch->elapsed_usec = 0;
    if (watch->is_running) {
        getrusage(RUSAGE_SELF, watch->rsg);
        
        watch->started_usec  = (uint64_t) watch->rsg->ru_utime.tv_sec;
        watch->started_usec += (uint64_t) watch->rsg->ru_stime.tv_sec;
        watch->started_usec *= 1000000;        
        watch->started_usec += (uint64_t) watch->rsg->ru_utime.tv_usec;
        watch->started_usec += (uint64_t) watch->rsg->ru_stime.tv_usec;
    }
}
//----------------------------------------------------------------------------
double get_stopwatch_elapsed(stopwatch_t* const watch) {
    return  (watch->elapsed_usec / 1000000.0);
}
//----------------------------------------------------------------------------
