//
// WARNING:
// This file was taken from the TIFA library
//     http://www.lix.polytechnique.fr/Labo/Jerome.Milan/tifa/tifa.xhtml
// and is subject to the LGPL version 2.1 or later.
//

#if !defined(_APIP_STOPWATCH_H_)
#define _APIP_STOPWATCH_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <sys/resource.h>
#include <sys/time.h>
#include <stdint.h>
#include <stdbool.h>

struct struct_stopwatch_t {
    struct   rusage rsg[1];
    uint64_t started_usec;
    uint64_t elapsed_usec;
    bool     is_running;
};
typedef struct struct_stopwatch_t stopwatch_t;

void init_stopwatch(stopwatch_t* const watch);
void start_stopwatch(stopwatch_t* const watch);
void stop_stopwatch(stopwatch_t* const watch);
void reset_stopwatch(stopwatch_t* const watch);
double get_stopwatch_elapsed(stopwatch_t* const watch);

#ifdef __cplusplus
}
#endif

#endif
